<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">

    <modelVersion>4.0.0</modelVersion>
    <groupId>com.github.slimefun</groupId>
    <artifactId>Slimefun</artifactId>

    <!-- Our default version will be UNOFFICIAL, this will prevent auto updates -->
    <!-- from overriding our local test file -->
    <version>4.9-UNOFFICIAL</version>
    <inceptionYear>2013</inceptionYear>
    <packaging>jar</packaging>

    <!-- Project Info -->
    <description>Slimefun is a Spigot/Paper plugin that simulates a modpack-like atmosphere by adding over 500 new items and recipes to your Minecraft Server.</description>
    <url>https://github.com/Slimefun/Slimefun4</url>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <maven.compiler.source>1.8</maven.compiler.source>
        <maven.compiler.target>1.8</maven.compiler.target>

        <!-- Spigot properties -->
        <spigot.version>1.16.4</spigot.version>
        <spigot.javadocs>https://hub.spigotmc.org/javadocs/spigot/</spigot.javadocs>

        <!-- Default settings for sonarcloud.io -->
        <sonar.projectKey>Slimefun_Slimefun4</sonar.projectKey>
        <sonar.organization>slimefun</sonar.organization>
        <sonar.host.url>https://sonarcloud.io</sonar.host.url>
        <sonar.log.level>DEBUG</sonar.log.level>
        <sonar.coverage.jacoco.xmlReportPaths>target/site/jacoco/jacoco.xml</sonar.coverage.jacoco.xmlReportPaths>
    </properties>

    <!-- Bug Tracker -->
    <issueManagement>
        <system>GitHub Issues</system>
        <url>https://github.com/Slimefun/Slimefun4/issues</url>
    </issueManagement>

    <!-- License -->
    <licenses>
        <license>
            <name>GNU General Public License v3.0</name>
            <url>https://github.com/Slimefun/Slimefun4/blob/master/LICENSE</url>
            <distribution>repo</distribution>
        </license>
    </licenses>

    <!-- The repositories which host our dependencies -->
    <repositories>
        <repository>
            <id>spigot-repo</id>
            <url>https://hub.spigotmc.org/nexus/content/repositories/snapshots</url>
        </repository>
        <repository>
            <id>paper-repo</id>
            <url>https://papermc.io/repo/repository/maven-public</url>
        </repository>
        <repository>
            <id>jitpack.io</id>
            <url>https://jitpack.io</url>
        </repository>
        <repository>
            <id>worldedit-repo</id>
            <url>https://maven.sk89q.com/repo</url>
        </repository>
        <repository>
            <id>codemc-repo</id>
            <url>https://repo.codemc.org/repository/maven-public</url>
        </repository>
        <repository>
            <id>placeholderapi-repo</id>
            <url>https://repo.extendedclip.com/content/repositories/placeholderapi</url>
        </repository>
        <repository>
            <id>walshy-public</id>
            <url>https://repo.walshy.dev/public</url>
        </repository>
    </repositories>

    <!-- Build settings -->
    <build>
        <sourceDirectory>${project.basedir}/src/main/java</sourceDirectory>
        <testSourceDirectory>${project.basedir}/src/test/java</testSourceDirectory>
        <defaultGoal>clean package</defaultGoal>

        <!-- The name of the final jar -->
        <finalName>${project.name} v${project.version}</finalName>

        <plugins>
            <!-- Compiler plugin -->
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.8.1</version>
                <configuration>
                    <excludes>
                        <!-- package info files are only important for Javadocs -->
                        <!-- We can safely exclude them from the final jar -->
                        <exclude>**/package-info.java</exclude>
                    </excludes>
                </configuration>
            </plugin>

            <!-- Attach sources -->
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-source-plugin</artifactId>
                <version>3.2.1</version>

                <executions>
                    <execution>
                        <id>attach-sources</id>
                        <goals>
                            <goal>jar</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>

            <!-- Plugin for Unit Tests -->
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>3.0.0-M5</version>

                <configuration>
                    <junitArtifactName>org.junit.jupiter:junit-jupiter</junitArtifactName>
                    <trimStackTrace>false</trimStackTrace>
                </configuration>
            </plugin>

            <!-- Sonarcloud Scanner -->
            <plugin>
                <groupId>org.sonarsource.scanner.maven</groupId>
                <artifactId>sonar-maven-plugin</artifactId>
                <version>3.7.0.1746</version>
            </plugin>

            <!-- Code Coverage Reports -->
            <plugin>
                <groupId>org.jacoco</groupId>
                <artifactId>jacoco-maven-plugin</artifactId>
                <version>0.8.6</version>

                <executions>
                    <execution>
                        <id>prepare</id>

                        <goals>
                            <goal>prepare-agent</goal>
                        </goals>
                    </execution>

                    <execution>
                        <id>report</id>
                        <phase>test</phase>

                        <goals>
                            <goal>report</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>

            <!-- Dependency shading -->
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-shade-plugin</artifactId>
                <version>3.2.4</version>

                <configuration>
                    <!-- Relocate these to avoid clashes and conflicts -->
                    <relocations>
                        <relocation>
                            <pattern>io.github.thebusybiscuit.cscorelib2</pattern>
                            <shadedPattern>me.mrCookieSlime.Slimefun.cscorelib2</shadedPattern>
                        </relocation>
                        <relocation>
                            <pattern>io.papermc.lib</pattern>
                            <shadedPattern>io.github.thebusybiscuit.slimefun4.libraries.paperlib</shadedPattern>
                        </relocation>
                        <relocation>
                            <pattern>kong.unirest</pattern>
                            <shadedPattern>io.github.thebusybiscuit.slimefun4.libraries.unirest</shadedPattern>
                        </relocation>
                    </relocations>

                    <!-- Exclude unneeded metadata files from shaded dependencies -->
                    <filters>
                        <filter>
                            <artifact>*:*</artifact>
                            <excludes>
                                <exclude>META-INF/*</exclude>
                            </excludes>
                        </filter>
                    </filters>
                </configuration>

                <executions>
                    <execution>
                        <phase>package</phase>
                        <goals>
                            <goal>shade</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>

            <!-- Javadocs Settings -->
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-javadoc-plugin</artifactId>
                <version>3.2.0</version>

                <configuration>
                    <reportOutputDirectory>${project.basedir}</reportOutputDirectory>
                    <destDir>docs</destDir>

                    <doctitle>Slimefun4 - Javadocs</doctitle>
                    <windowtitle>Slimefun4 - Javadocs</windowtitle>
                    <detectOfflineLinks>false</detectOfflineLinks>
                    <additionalJOption>-html5</additionalJOption>

                    <!-- We can reference the Spigot API in our Javadocs -->
                    <links>
                        <link>${spigot.javadocs}</link>
                    </links>

                    <!-- We can group packages together in our Javadocs -->
                    <groups>
                        <group>
                            <title>Slimefun4 - API</title>
                            <packages>io.github.thebusybiscuit.slimefun4.api*</packages>
                        </group>
                        <group>
                            <title>Slimefun4 - Core packages</title>
                            <packages>io.github.thebusybiscuit.slimefun4.core*</packages>
                        </group>
                        <group>
                            <title>Slimefun4 - Implementations</title>
                            <packages>io.github.thebusybiscuit.slimefun4.implementation*</packages>
                        </group>
                        <group>
                            <title>Slimefun4 - Common utility packages</title>
                            <packages>io.github.thebusybiscuit.slimefun4.utils*</packages>
                        </group>
                        <group>
                            <title>Slimefun4 - Items</title>
                            <packages>io.github.thebusybiscuit.slimefun4.implementation.items*</packages>
                        </group>
                        <group>
                            <title>Slimefun4 - Multiblocks</title>
                            <packages>io.github.thebusybiscuit.slimefun4.implementation.items.multiblocks*</packages>
                        </group>
                        <group>
                            <title>Slimefun4 - Electrical Machines</title>
                            <packages>io.github.thebusybiscuit.slimefun4.implementation.items.electric*</packages>
                        </group>
                        <group>
                            <title>Slimefun4 - Old packages</title>
                            <packages>me.mrCookieSlime.Slimefun*</packages>
                        </group>
                    </groups>
                </configuration>
            </plugin>
        </plugins>

        <resources>

            <!-- Resources we want to include, e.g. configs or language files -->
            <resource>
                <directory>${basedir}/src/main/resources</directory>
                <filtering>true</filtering>

                <includes>
                    <include>*</include>
                    <include>tags/*</include>
                    <include>languages/*</include>
                </includes>
            </resource>

            <!-- We also want to include our LICENSE file -->
            <resource>
                <directory>${basedir}</directory>

                <includes>
                    <include>LICENSE</include>
                </includes>
            </resource>
        </resources>
    </build>

    <dependencies>
        <!-- Hard dependencies -->
        <dependency>
            <groupId>org.spigotmc</groupId>
            <artifactId>spigot-api</artifactId>
            <version>${spigot.version}-R0.1-SNAPSHOT</version>
            <scope>provided</scope>
        </dependency>
        <dependency>
            <groupId>com.github.TheBusyBiscuit</groupId>
            <artifactId>CS-CoreLib</artifactId>
            <version>1.7</version>
            <scope>provided</scope>
        </dependency>

        <!-- Development dependencies -->
        <dependency>
            <groupId>com.google.code.findbugs</groupId>
            <artifactId>jsr305</artifactId>
            <version>3.0.2</version>
            <scope>provided</scope>
        </dependency>

        <!-- Testing dependencies -->
        <dependency>
            <groupId>org.junit.jupiter</groupId>
            <artifactId>junit-jupiter</artifactId>
            <version>5.7.0</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>com.github.seeseemelk</groupId>
            <artifactId>MockBukkit-v1.16</artifactId>
            <version>0.20.0</version>
            <scope>test</scope>
            <exclusions>
                <exclusion>
                    <!-- We use javax.annotation instead. Excluding this -->
                    <!-- prevents us from using inconsistent annotations -->
                    <groupId>org.jetbrains</groupId>
                    <artifactId>annotations</artifactId>
                </exclusion>
            </exclusions>
        </dependency>
        <dependency>
            <groupId>org.mockito</groupId>
            <artifactId>mockito-core</artifactId>
            <version>3.7.0</version>
            <scope>test</scope>
        </dependency>

        <!-- Shaded packages -->
        <dependency>
            <groupId>com.github.TheBusyBiscuit</groupId>
            <artifactId>CS-CoreLib2</artifactId>
            <version>0.29.1</version>
            <scope>compile</scope>
        </dependency>
        <dependency>
            <groupId>io.papermc</groupId>
            <artifactId>paperlib</artifactId>
            <version>1.0.6</version>
            <scope>compile</scope>
        </dependency>
        <dependency>
            <groupId>com.konghq</groupId>
            <artifactId>unirest-java</artifactId>
            <version>3.11.10</version>
            <scope>compile</scope>
            <exclusions>
                <exclusion>
                    <groupId>com.google.code.gson</groupId>
                    <artifactId>gson</artifactId>
                </exclusion>
            </exclusions>
        </dependency>

        <!-- Third party plugin integrations / soft dependencies -->
        <dependency>
            <groupId>com.sk89q.worldedit</groupId>
            <artifactId>worldedit-bukkit</artifactId>
            <version>7.2.1</version>
            <scope>provided</scope>
            <exclusions>
                <exclusion>
                    <!-- This one is ignored because it pops up everytime -->
                    <!-- I try to import File... yes, I want java.io.File -->
                    <groupId>de.schlichtherle</groupId>
                    <artifactId>truezip</artifactId>
                </exclusion>
                <exclusion>
                    <groupId>net.java.truevfs</groupId>
                    <artifactId>truevfs-profile-default_2.13</artifactId>
                </exclusion>
            </exclusions>
        </dependency>
        <dependency>
            <groupId>com.gmail.nossr50.mcMMO</groupId>
            <artifactId>mcMMO</artifactId>
            <version>2.1.171</version>
            <scope>provided</scope>
            <exclusions>
                <exclusion>
                    <!-- We use javax.annotation instead. Excluding this -->
                    <!-- prevents us from using inconsistent annotations -->
                    <groupId>org.jetbrains</groupId>
                    <artifactId>annotations</artifactId>
                </exclusion>
                <exclusion>
                    <groupId>com.sk89q.worldguard</groupId>
                    <artifactId>worldguard-core</artifactId>
                </exclusion>
                <exclusion>
                    <groupId>com.sk89q.worldguard</groupId>
                    <artifactId>worldguard-legacy</artifactId>
                </exclusion>
                <exclusion>
                    <!-- We do not want to use the wrong TextComponents by -->
                    <!-- accident. If we use adventure, then we will add -->
                    <!-- it ourselves. -->
                    <groupId>net.kyori</groupId>
                    <artifactId>*</artifactId>
                </exclusion>
            </exclusions>
        </dependency>
        <dependency>
            <groupId>me.clip</groupId>
            <artifactId>placeholderapi</artifactId>
            <version>2.10.9</version>
            <scope>provided</scope>
            <exclusions>
                <exclusion>
                    <!-- We use javax.annotation instead. Excluding this -->
                    <!-- prevents us from using inconsistent annotations -->
                    <groupId>org.jetbrains</groupId>
                    <artifactId>annotations</artifactId>
                </exclusion>
            </exclusions>
        </dependency>
        <dependency>
            <groupId>me.minebuilders</groupId>
            <artifactId>clearlag-core</artifactId>
            <version>3.1.6</version>
            <scope>provided</scope>
        </dependency>
        <dependency>
            <groupId>com.github.LoneDev6</groupId>
            <artifactId>itemsadder-api</artifactId>
            <version>0.1.2</version>
            <scope>provided</scope>
            <exclusions>
                <exclusion>
                    <!-- We use javax.annotation instead. Excluding this -->
                    <!-- prevents us from using inconsistent annotations -->
                    <groupId>org.jetbrains</groupId>
                    <artifactId>annotations</artifactId>
                </exclusion>
            </exclusions>
        </dependency>
    </dependencies>
</project>
